<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item label="院区" prop="wardId">
        <el-select v-model="queryParams.wardId" filterable clearable style="width: 240px">
          <el-option label="全部" value=""></el-option>
          <el-option
            v-for="item in wardIdList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="应用科室" prop="deptIds">
        <TreeDept
          v-model="queryParams.deptId"
          clearable
          style="width: 240px"
          :options="deptList"
          :autoFetch="false"
          :props="{ emitPath: true }"
        />
      </el-form-item>
      <el-form-item label="员工姓名" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入员工姓名"
          clearable
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">
          搜索
        </el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd">
          新增员工
        </el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="pageList" border>
      <el-table-column
        align="center"
        label="序号"
        type="index"
        :index="(index) => (queryParams.pageNum - 1) * queryParams.pageSize + index + 1"
        width="120"
      />
      <el-table-column align="center" label="院区" prop="wardName" :show-overflow-tooltip="true" />
      <el-table-column
        align="center"
        label="员工姓名"
        prop="doctorName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="所属科室"
        prop="deptName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="联系电话"
        prop="phoneNumber"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="证件号"
        prop="cardNumber"
        :show-overflow-tooltip="true"
      />
      <!-- <el-table-column align="center" label="状态" prop="roleKey" :show-overflow-tooltip="true" /> -->
      <el-table-column
        align="center"
        label="操作"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button size="mini" type="text" @click="handleEdit(scope.row)">编辑</el-button>
          <el-button size="mini" type="text" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <CrudPopup ref="crud" />
    <StaffSelectorPopup ref="doctorSelector" />
  </div>
</template>

<script>
import ApiButton from "@/components/ApiButton/index.vue";
import StaffSelectorPopup from "./components/StaffSelectorPopup";
import CrudPopup from "./components/CrudPopup";
import TreeDept from "@/components/TreeDept";
import { staffPageList, editStaff, delStaff, getAllHospital, getTreeHospDept } from "@/api/admin";

export default {
  name: "StaffManage",
  components: {
    ApiButton,
    StaffSelectorPopup,
    CrudPopup,
    TreeDept,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName: undefined,
        roleKey: undefined,
        status: "",
        wardId: "", // 院区ID
        deptId: []
      },
      pageList: [],
      wardIdList: [], // 院区列表
      deptList: [] // 科室数据
    };
  },
  created() {
    this.loadData();
  },
  activated() {
    this.loadData();
  },
  watch: {
    "queryParams.wardId"(val) {
      const wardId = val;
      if (wardId) {
        this.queryParams.deptId = [];
        this.getDeptList(wardId);
        this.getList(wardId);
      } else {
        this.queryParams.deptId = [];
        this.pageList = [];
        this.getDeptList();
        this.getList();
      }
    },
    "queryParams.deptId"(val) {
      const deptId = val[1] || val[0];
      if (deptId) {
        this.getList(deptId);
      } else {
        this.pageList = [];
      }
    },
  },
  methods: {
    loadData() {
      this.loadWardIdList();
      this.getDeptList();
      this.getList();
    },
    /*获取院区列表*/
    async loadWardIdList() {
      const res = await getAllHospital();
      this.wardIdList = res.data;
    },
    /*获取科室数据*/
    async getDeptList(wardId) {
      const res = await getTreeHospDept({ wardId : wardId });
      this.deptList = res.data || [];
    },
    /** 查询角色列表 */
    getList() {
      this.loading = true;
      const params = JSON.parse(JSON.stringify(this.queryParams));
      params.deptId = params.deptId?.length === 2 ?
        params.deptId.slice(-1).toString() :
        params.deptId?.length === 1 && params.deptId.slice(-1).toString() || '';
      staffPageList(this.addDateRange(params, this.dateRange))
        .then((res) => {
          const { data: { list, page } } = res
          this.pageList = list || [];
          this.total = page?.total || 0;
        })
        .finally(() => {
          this.loading = false;
        });
    },

    // 表单重置
    reset() {
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getDeptList(this.queryParams.wardId);
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增患者 */
    handleAdd() {
      this.$refs.doctorSelector.open().then(this.getList);
    },
    /** 编辑 */
    handleEdit(item) {
      this.$refs.crud
        .open({
          ...item,
          api: (form) => {
            return editStaff({ ...form, id: item.id }).then(() => {
              this.$message.success("编辑成功");
            });
          },
          isEdit: true,
        })
        .then(this.getList);
    },
    handleDelete(item) {
      this.$modal
        .confirm("是否确认删除？")
        .then(async () => {
          await delStaff(item.id);
          this.$message.success("操作成功");
          this.getList();
        })
        .catch(() => {});
    },
  },
};
</script>
<style lang="scss" scoped></style>
